Index: trunk/NEMO/OPA_SRC/TRD/trdvor_oce.F90
===================================================================
--- trunk/NEMO/OPA_SRC/TRD/trdvor_oce.F90	(revision 485)
+++ trunk/NEMO/OPA_SRC/TRD/trdvor_oce.F90	(revision 503)
@@ -4,31 +4,37 @@
    !! Ocean trends :   set vorticity trend variables
    !!======================================================================
+   !! History :  9.0  ! ???
+   !!----------------------------------------------------------------------
+
+   !!----------------------------------------------------------------------
+   USE par_oce      ! ocean parameters
+
+   IMPLICIT NONE
+   PRIVATE
+
+#if defined key_trdvor
+   LOGICAL, PUBLIC, PARAMETER ::   lk_trdvor = .TRUE.     !: momentum trend flag
+#else
+   LOGICAL, PUBLIC, PARAMETER ::   lk_trdvor = .FALSE.    !: momentum trend flag
+#endif
+   !!* vorticity trends index
+   INTEGER, PUBLIC, PARAMETER ::   jpltot_vor = 11  !: Number of vorticity trend terms
+   !
+   INTEGER, PUBLIC, PARAMETER ::   jpvor_prg =  1   !: Pressure Gradient Trend
+   INTEGER, PUBLIC, PARAMETER ::   jpvor_keg =  2   !: KE Gradient Trend
+   INTEGER, PUBLIC, PARAMETER ::   jpvor_rvo =  3   !: Relative Vorticity Trend
+   INTEGER, PUBLIC, PARAMETER ::   jpvor_pvo =  4   !: Planetary Vorticity Term Trend
+   INTEGER, PUBLIC, PARAMETER ::   jpvor_ldf =  5   !: Horizontal Diffusion Trend
+   INTEGER, PUBLIC, PARAMETER ::   jpvor_zad =  6   !: Vertical Advection Trend
+   INTEGER, PUBLIC, PARAMETER ::   jpvor_zdf =  7   !: Vertical Diffusion Trend
+   INTEGER, PUBLIC, PARAMETER ::   jpvor_spg =  8   !: Surface Pressure Grad. Trend
+   INTEGER, PUBLIC, PARAMETER ::   jpvor_bev =  9   !: Beta V
+   INTEGER, PUBLIC, PARAMETER ::   jpvor_swf = 10   !: wind stress forcing term
+   INTEGER, PUBLIC, PARAMETER ::   jpvor_bfr = 11   !: bottom friction term
+
    !!----------------------------------------------------------------------
    !!  OPA 9.0 , LOCEAN-IPSL (2005) 
    !! $Header$ 
-   !! This software is governed by the CeCILL licence see modipsl/doc/NEMO_CeCILL.txt 
-   !!----------------------------------------------------------------------
-   !!----------------------------------------------------------------------
-   !! * Modules used
-   USE par_oce      ! ocean parameters
-
-   IMPLICIT NONE
-   PUBLIC
-
-   INTEGER,PARAMETER :: jplvor = 11     ! Number of vorticity trend terms
-
-   INTEGER, PARAMETER ::            &  !: vorticity trends index
-      jpvorprg = 1,   &  !: Pressure Gradient Trend
-      jpvorkeg = 2,   &  !: KE Gradient Trend
-      jpvorrvo = 3,   &  !: Relative Vorticity Trend
-      jpvorpvo = 4,   &  !: Planetary Vorticity Term Trend
-      jpvorldf = 5,   &  !: Horizontal Diffusion Trend
-      jpvorzad = 6,   &  !: Vertical Advection Trend
-      jpvorzdf = 7,   &  !: Vertical Diffusion Trend
-      jpvorspg = 8,   &  !: Surface Pressure Grad. Trend
-      jpvorbev = 9,   &  !: Beta V
-      jpvorswf =10,   &  !: wind stress forcing term
-      jpvorbfr =11       !: bottom friction term
-
-  !!======================================================================
+   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
+   !!======================================================================
 END MODULE trdvor_oce
Index: trunk/NEMO/OPA_SRC/ZDF/zdfkpp.F90
===================================================================
--- trunk/NEMO/OPA_SRC/ZDF/zdfkpp.F90	(revision 485)
+++ trunk/NEMO/OPA_SRC/ZDF/zdfkpp.F90	(revision 503)
@@ -5,12 +5,17 @@
    !!                 turbulent closure parameterization
    !!=====================================================================
+   !! History :  8.1  ! 00-03 (W.G. Large, J. Chanut) Original code
+   !!            8.1  ! 02-06 (J.M. Molines) for real case CLIPPER  
+   !!            8.2  ! 03-10 (Chanut J.) re-writting
+   !!            9.0  ! 05-01 (C. Ethe) Free form, F90
+   !!----------------------------------------------------------------------
 #if defined key_zdfkpp   ||   defined key_esopa
    !!----------------------------------------------------------------------
    !!   'key_zdfkpp'                                             KPP scheme
    !!----------------------------------------------------------------------
+   !!----------------------------------------------------------------------
    !!   zdf_kpp      : update momentum and tracer Kz from a kpp scheme
    !!   zdf_kpp_init : initialization, namelist read, and parameters control
    !!----------------------------------------------------------------------
-   !! * Modules used
    USE oce             ! ocean dynamics and active tracers 
    USE dom_oce         ! ocean space and time domain
@@ -28,18 +33,14 @@
    PRIVATE
 
-   !! * Routine accessibility
-   PUBLIC zdf_kpp   ! routine called by step.F90
-   PUBLIC tra_kpp   ! routine called by step.F90
-
-   !! * Share Module variables
-   LOGICAL, PUBLIC, PARAMETER ::  &
-      lk_zdfkpp = .TRUE.          !: KPP vertical mixing flag
-   REAL(wp), PUBLIC, DIMENSION(jpi,jpj,jpk) ::   & 
-      ghats                       ! non-local scalar mixing term (gamma/<ws>o)
+   PUBLIC   zdf_kpp   ! routine called by step.F90
+   PUBLIC   tra_kpp   ! routine called by step.F90
+
+   LOGICAL, PUBLIC, PARAMETER ::   lk_zdfkpp = .TRUE.    !: KPP vertical mixing flag
+   REAL(wp), PUBLIC, DIMENSION(jpi,jpj,jpk) ::   ghats   !: non-local scalar mixing term (gamma/<ws>o)
    REAL(wp), PUBLIC, DIMENSION(jpi,jpj) ::   & 
-      wt0                   ,  &  ! surface temperature flux for non local flux
-      ws0                   ,  &  ! surface salinity flux for non local flux
-      hkpp                        ! boundary layer depht
-   !! * Module variables
+      wt0                   ,  &  !: surface temperature flux for non local flux
+      ws0                   ,  &  !: surface salinity flux for non local flux
+      hkpp                        !: boundary layer depht
+
    INTEGER ::                  & !!! ** kpp namelist (namkpp) **
       nave  =  1            ,  &  ! = 0/1 flag for horizontal average on avt, avmu, avmv
@@ -148,9 +149,8 @@
    !!   OPA 9.0 , LOCEAN-IPSL   (2005)
    !! $Header$ 
-   !! This software is governed by the CeCILL licence see modipsl/doc/NEMO_CeCILL.txt 
+   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
 
 CONTAINS
-
 
    SUBROUTINE zdf_kpp ( kt )
@@ -184,23 +184,9 @@
       !!                update avt, avmu, avmv (before vertical eddy coef.)
       !!
-      !!   References :       
-      !!         Large W.G., Mc Williams J.C. and Doney S.C.              
+      !! References : Large W.G., Mc Williams J.C. and Doney S.C.              
       !!         Reviews of Geophysics, 32, 4, November 1994
       !!         Comments in the code refer to this paper, particularly 
       !!         the equation number. (LMD94, here after)
-      !!
-      !!   Modifications :
-      !!   --------------
-      !!     original  :  00-03 (LARGE W.G.)
-      !!     additions :  00-04 (CHANUT J.)
-      !!               :  02-06 (MOLINES J.M. for real case CLIPPER)
-      !!               :  03-10 (CHANUT J.)
-      !!
-      !! History :
-      !!   8.1  !  00-03  (J. Chanut)  Original code
-      !!   8.1  !  00-04  (J.M. Molines) for real case CLIPPER  
-      !!   9.0  !  05-01  (C. Ethe) Free form, F90
       !!----------------------------------------------------------------------
-      !! * Modules used
 #if defined  key_zdfddm
       USE oce     , zviscos => ua,      &  ! temp. array for viscosities use ua as workspace
@@ -211,15 +197,9 @@
          &          zdiffut => ta          ! temp. array for diffusivities use sa as workspace
 #endif
-
-
-      !! * arguments
-      INTEGER, INTENT( in  ) ::         &
-         kt                                ! ocean time step
-
-      !! * local declarations
-      INTEGER ::                        &
-         ji, jj, jk                        ! dummy loop indices
-      INTEGER ::                        &  !
-         ikbot, jkmax, jkm1, jkp2          !
+      !!
+      INTEGER, INTENT( in  ) ::   kt   ! ocean time step
+      !!
+      INTEGER ::   ji, jj, jk              ! dummy loop indices
+      INTEGER ::   ikbot, jkmax, jkm1, jkp2   !
 
       REAL(wp), DIMENSION(jpi,jpj) ::   & !!! Surface buoyancy forcing, friction velocity
@@ -1251,11 +1231,9 @@
          IF(ln_ctl) THEN
 #if defined key_zdfddm
-            CALL prt_ctl(tab3d_1=avt  , clinfo1=' kpp  - t: ', tab3d_2=avs , clinfo2=' s: ', &
-               &         ovlap=1, kdim=jpk)
+            CALL prt_ctl(tab3d_1=avt , clinfo1=' kpp  - t: ', tab3d_2=avs , clinfo2=' s: ', ovlap=1, kdim=jpk)
 #else
-            CALL prt_ctl(tab3d_1=avt  , clinfo1=' kpp  - t: ', ovlap=1, kdim=jpk)
-#endif
-            CALL prt_ctl(tab3d_1=avmu  , clinfo1='       u: ', tab3d_2=avmv , clinfo2=' v: ', &
-               &         ovlap=1, kdim=jpk)
+            CALL prt_ctl(tab3d_1=avt , clinfo1=' kpp  - t: ', ovlap=1, kdim=jpk)
+#endif
+            CALL prt_ctl(tab3d_1=avmu, clinfo1='       u: ', tab3d_2=avmv , clinfo2=' v: ', ovlap=1, kdim=jpk)
          ENDIF
 
@@ -1312,10 +1290,9 @@
          ztrds(:,:,:) = sa(:,:,:) - ztrds(:,:,:)
 !!bug gm jpttdzdf ==> jpttkpp
-         CALL trd_mod(ztrdt, ztrds, jpttdzdf, 'TRA', kt)
+         CALL trd_mod(ztrdt, ztrds, jptra_trd_zdf, 'TRA', kt)
       ENDIF
 
-      IF(ln_ctl) THEN         ! print mean trends (used for debugging)
-         CALL prt_ctl(tab3d_1=ta, clinfo1=' kpp  - Ta: ', mask1=tmask, &
-            &         tab3d_2=sa, clinfo2=       ' Sa: ', mask2=tmask, clinfo3='tra')
+      IF(ln_ctl)   CALL prt_ctl( tab3d_1=ta, clinfo1=' kpp  - Ta: ', mask1=tmask,   &
+         &                       tab3d_2=sa, clinfo2=       ' Sa: ', mask2=tmask, clinfo3='tra' )
       ENDIF
 
@@ -1594,5 +1571,4 @@
       END DO
 #endif
-
    END SUBROUTINE zdf_kpp_init
 
Index: trunk/NEMO/OPA_SRC/opa.F90
===================================================================
--- trunk/NEMO/OPA_SRC/opa.F90	(revision 485)
+++ trunk/NEMO/OPA_SRC/opa.F90	(revision 503)
@@ -62,7 +62,5 @@
    USE cpl             ! coupled ocean/atmos.              (cpl_init routine)
    USE ocfzpt          ! ocean freezing point              (oc_fz_pt routine)
-   USE trdicp          ! momentum/tracers trends       (trd_icp_init routine)
-   USE trdvor          ! vorticity trends              (trd_vor_init routine)
-   USE trdmld          ! tracer mixed layer trends     (trd_mld_init routine)
+   USE trdmod          ! momentum/tracers trends       (trd_mod_init routine)
    USE flxfwb          ! freshwater budget correction  (flx_fwb_init routine)
    USE flxmod          ! thermohaline forcing of the ocean (flx_init routine)
@@ -280,15 +278,6 @@
       CALL zdf_init                             ! Vertical ocean physics
 
-      !                                     ! Ocean trends
-      ! Control parameters 
-      IF( lk_trdtra .OR. lk_trdmld )   l_trdtra = .TRUE.
-      IF( lk_trddyn .OR. lk_trdvor )   l_trddyn = .TRUE.
-
-      IF( lk_trddyn .OR. lk_trdtra )   &
-         &            CALL trd_icp_init         ! active tracers and/or momentum
-
-      IF( lk_trdmld ) CALL trd_mld_init         ! mixed layer
-
-      IF( lk_trdvor ) CALL trd_vor_init         ! vorticity
+      CALL trd_mod_init                         ! Mixed-layer/Vorticity/Integral constraints trends
+
 
 #if defined key_passivetrc
Index: trunk/NEMO/OPA_SRC/step.F90
===================================================================
--- trunk/NEMO/OPA_SRC/step.F90	(revision 485)
+++ trunk/NEMO/OPA_SRC/step.F90	(revision 503)
@@ -102,4 +102,6 @@
    USE trdicp          ! Ocean momentum/tracers trends    (trd_wri routine)
    USE trdmld          ! mixed-layer trends               (trd_mld routine)
+   USE trdmld_rst      ! restart for mixed-layer trends
+   USE trdmod_oce      ! ocean momentum/tracers trends
    USE trdvor          ! vorticity budget                 (trd_vor routine)
    USE diagap          ! hor. mean model-data gap         (dia_gap routine)
@@ -424,4 +426,5 @@
                             CALL rst_write  ( kstp )             ! ocean model: restart file output
          IF( lk_obc     )   CALL obc_rst_wri( kstp )             ! ocean model: open boundary restart file output
+         IF( lk_trdmld  )   CALL trd_mld_rst_write( kstp )       ! ocean model: restart file output for trends diagnostics
                             CALL dia_wri    ( kstp, indic )      ! ocean model: outputs
 
